package exchanges
{
	/**ユーザ情報クラス*/
	[Bindable]
	public class CUserData
	{
		// メンバ変数
		
		protected var m_UserId:String;
		/**ユーザId*/
		public function get UserId():String
		{
			return m_UserId;
		}
		public function set UserId(value:String):void
		{
			m_UserId = value;
		}
		
		/**名前*/
		protected var m_firstName:String;		// 名前
		protected var m_middleName:String;		// ミドルネーム
		protected var m_lastName:String;		// 苗字
		
		
		/**ユーザ名*/
		public function get FirstName():String
		{
			return m_firstName;
		}
		public function set FirstName(value:String):void
		{
			m_firstName = value;
		}
		
		public function get MiddleName():String
		{
			return m_middleName;
		}
		public function set MiddleName(value:String):void
		{
			m_middleName = value;
		}
		
		public function get LastName():String
		{
			return m_lastName;
		}
		public function set LastName(value:String):void
		{
			m_lastName = value;
		}
		
		protected var m_Belong:String;
		/**ユーザ所属*/
		public function get Belong():String
		{
			return m_Belong;
		}
		public function set Belong(value:String):void
		{
			m_Belong = value;
		}
		
		protected var m_Authorize:String;
		/**権限*/
		public function get Authorize():String
		{
			return m_Authorize;
		}
		public function set Authorize(value:String):void
		{
			m_Authorize = value;
		}
		
		// メソッド
		/**
		 * (U) public function CUserData
		 * (F) コンストラクタ
		 * (V)	
		 * (R) 	
		 */ 
		public function CUserData()
		{
			init();
		}
		
		/**
		 * (U) public function init
		 * (F) オブジェクトの初期化
		 * (V)	なし
		 * (R) 	なし
		 */
		public function init():void
		{
			m_UserId		= "";
			
			// 2010/09/15 otsuka mod 名前を詳細に分けた
			m_firstName		= "";
			m_middleName	= "";
			m_lastName		= "";
			//-----------------------------------------
			
			m_Belong		= "";
			m_Authorize		= "";
		}
		
		/**
		 * (U) public function copy
		 * (F) オブジェクトのコピー
		 * (V)	source:CUserData	[i]コピー元オブジェクト
		 * (R) 	なし
		 */
		public function copy(source:CUserData):void
		{
			m_UserId		= source.m_UserId;
			
			m_firstName		= source.m_firstName;
			m_middleName	= source.m_middleName;
			m_lastName		= source.m_lastName;
			
			m_Belong		= source.m_Belong;
			m_Authorize		= source.m_Authorize;
		}
		
		
		/**
		 * (U) public function fromXML
		 * (F) XML形式のデータを読み込む
		 * (V)	node:XML	[i]XMLオブジェクト	
		 * (R) 	なし
		 */
		public function fromXML(node:XML):Boolean
		{
			var lst:XMLList;	
			
			lst = node.elements("UserId");			
			if(lst.length() != 1) return false;
			this.m_UserId = lst[0];
			
			lst = node.elements("firstName");			
			if(lst.length() != 1) return false;
			this.m_firstName = lst[0];
			
			lst = node.elements("middleName");			
			if(lst.length() != 1) return false;
			this.m_middleName = lst[0];
			
			lst = node.elements("lastName");			
			if(lst.length() != 1) return false;
			this.m_lastName = lst[0];
			
			lst = node.elements("Belong");
			if(lst.length() != 1) return false;
			this.m_Belong = lst[0];
			
			lst = node.elements("Authorize");
			if(lst.length() != 1) return false;
			this.m_Authorize = lst[0];
				
			return true;
		}
		
		/**
		 * (U) public function toXML
		 * (F)	XMLオブジェクトの生成
		 * (V) 	なし
		 * (R)	XMLオブジェクト
		 */
		public function toXML():XML
		{
			var node:XML =
			new XML("<UserData>" + 
						" <UserId>" + this.m_UserId + "</UserId>" + 
						" <firstName>" + this.m_firstName + "</firstName>" +
						" <middleName>" + this.m_middleName + "</middleName>" +
						" <lastName>" + this.m_lastName + "</lastName>" +
						" <Belong>" + this.m_Belong + "</Belong>" +
						" <Authorize>" + this.m_Authorize + "</Authorize>" +
					"</UserData>");
			return node;
		}
		
		
		/**
		 * (U) public function getFullName
		 * (F)	フルネームの取得
		 * (V) 	なし
		 * (R)	フルネーム
		 */ 
		public function getFullName():String
		{
			var fullname:String = 
			(this.m_middleName == "") ? 
				this.m_lastName + " " + this.m_firstName :
				this.m_lastName + " " + this.m_middleName + " " + this.m_firstName;
			
			return fullname;
		}
		
	}
}